/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief ̧قAVR\ɊÂނIAR Cׂ߲AVR-GCC𓮂
 *		  ϸۂ܂B
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.ht
 *		mlB
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		xE-mail: avr@atmel.com
 *
 * $Revision: 2772 $
 * $Date: 2009-09-11 12:40:26 +0200 (fr, 11 sep 2009) $  \n
 *
 * 쌠 (c) 2008, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 ******************************************************************************/

#ifndef COMPILER_AVR_H
#define COMPILER_AVR_H

#ifndef F_CPU
/*! \brief ꂪɒ`ĂȂꍇ̊CPUg` */
#define F_CPU 2000000UL
#endif

#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>

/*! \brief ϸۂ͊荞݂ȍ~̺ނی삵܂B */
#define AVR_ENTER_CRITICAL_REGION( ) uint8_t volatile saved_sreg = SREG; \
									 cli();

/*! \brief ϸۂ͏AVR_ENTER_CRITICAL_REGIONƋɎgpȂ΂Ȃ炸A
 *		   ̂Ɋ荞݂͍Ăы܂B
 */
#define AVR_LEAVE_CRITICAL_REGION( ) SREG = saved_sreg;

#if defined( __ICCAVR__ )

#include <inavr.h>
#include <ioavr.h>
#include <intrinsics.h>
#include <pgmspace.h>

#ifndef __HAS_ELPM__
  #define _MEMATTR  __flash
#else /* __HAS_ELPM__ */
  #define _MEMATTR  __farflash
#endif /* __HAS_ELPM__ */

/*! \brief \c us s̒xs
 *
 *  F_CPUϸۂCPUۯg(Hz)`萔̒`x܂B
 *
 *  \ȍőx262.14 ms/(MHzł)F_CPUłB
 *
 *  \note IARׂ߲ɊւĂ͌F_CPU1000000UL{(1MHz)Ȃ΂Ȃ܂B
 */
#define delay_us( us )   ( __delay_cycles( ( F_CPU / 1000000UL ) * ( us ) ) )

/*! \brief ۾p
 *
 *  ۾IARׂ߲ɑ΂銄荞ݏٰݐ錾ͯ ْ̧o
 *  ߂Ɋs܂B͗s߂2̈قȂق۾A
 *  łȂA(ϸےuƂĎgp邱ƂłȂ#pragmaނ)C99
 *  _Pragma()[߂̎gpAISRp̗B̊֐\złȂA荞
 *  ޸̊蓖ĂKvłB
 *
 *  \note ꂪ^ꂽԂł̂ŁAϸۂёւȂłB
 */
#define PRAGMA(x) _Pragma( #x )
#define ISR(vec) PRAGMA( vector=vec ) __interrupt void handler_##vec(void)
#define sei( ) (__enable_interrupt( ))
#define cli( ) (__disable_interrupt( ))

/*! \brief ϸے` */
#define nop( ) (__no_operation())

/*! \brief ޯ ؾ ϸ */
#define watchdog_reset( ) (__watchdog_reset( ))

#define INLINE PRAGMA( inline=forced ) static

#define FLASH_DECLARE(x) _MEMATTR x
#define FLASH_STRING(x) ((_MEMATTR const char *)(x))
#define FLASH_STRING_T  char const _MEMATTR *
#define FLASH_BYTE_ARRAY_T uint8_t const _MEMATTR *
#define PGM_READ_BYTE(x) *(x)
#define PGM_READ_WORD(x) *(x)

#define SHORTENUM /**/

#elif defined( __GNUC__ )

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

/*! \brief GCCpdelay_usϸے` */
#define delay_us( us )   (_delay_us( us ))

#define INLINE static inline

/*! \brief ϸے` */
#define nop()   do { __asm__ __volatile__ ("nop"); } while (0)

#define MAIN_TASK_PROLOGUE int

#define MAIN_TASK_EPILOGUE() return -1;

#define SHORTENUM __attribute__ ((packed))

#else
#error Compiler not supported.
#endif

#endif
